<template>
    <div>
        <h1>Counter</h1>
        <p>This is a simple example of a Vue.js component & Vuex</p>
        <v-progress-linear :indeterminate="false" :value="currentCount*5"></v-progress-linear>

        <p>
            Current count (Vuex): <strong>{{ currentCount }}</strong>
        </p>
        <v-progress-linear :indeterminate="false" :value="autoCount"></v-progress-linear>

        <p>
            Auto count: <strong>{{ autoCount }}</strong>
        </p>
        <v-btn @click="incrementCounter()">Increment</v-btn>
        <v-btn @click="resetCounter()">Reset</v-btn>
    </div>
</template>

<script>
    import { mapActions, mapState } from 'vuex'

    export default {
        data() {
            return {
                autoCount: 0,
            }
        },

        computed: {
            ...mapState({
                currentCount: state => state.counter
            })
        },

        methods: {
            ...mapActions(['setCounter']),

            incrementCounter: function () {
                var counter = this.currentCount + 1;
                this.setCounter({ counter: counter });
            },
            resetCounter: function () {
                this.setCounter({ counter: 0 });
                this.autoCount = 0;
            }
        },

        created() {
            setInterval(() => {
                this.autoCount += 1
            }, 1000)
        }
    }
</script>

<style>

</style>
